unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, ExtCtrls, OleCtrls, SHDocVw, ComCtrls, Grids, DBGrids,
  HTTPProd, ToolWin, StdCtrls,mshtml,ActiveX,StrUtils, ImgList,
  HTTPApp,shellapi,IdGlobal;
const Ver='1.2';
type
TDBGrid=class(DBGrids.TDBGrid)
public
function DoMouseWheel(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean; override;
end;

type
  TfmMain = class(TForm)
    ADOConnection1: TADOConnection;
    Splitter1: TSplitter;
    ADOTopic: TADOQuery;
    DBGrid1: TDBGrid;
    ADOTopicTOPIC_ID: TAutoIncField;
    ADOTopicT_SUBJECT: TWideStringField;
    DataSource1: TDataSource;
    ADOTopicT_DATE: TWideStringField;
    PageProducer1: TPageProducer;
    ToolBar1: TToolBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter2: TSplitter;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    WebBrowser1: TWebBrowser;
    ADOTopicT_CODESYSTEM: TSmallintField;
    ADOTopicT_AUTHOR: TIntegerField;
    ADOTopicT_REPLIES: TIntegerField;
    ADOTopicT_LAST_POST: TWideStringField;
    ADOTopicT_GOOD: TWideStringField;
    Panel3: TPanel;
    Topic: TADOQuery;
    Reply: TADOQuery;
    ToolButton1: TToolButton;
    ADOConnection2: TADOConnection;
    ToolButton2: TToolButton;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    Memo1: TMemo;
    ToolButton8: TToolButton;
    Panel4: TPanel;
    tv: TTreeView;
    WebBrowserDemo: TWebBrowser;
    EditSearch: TEdit;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    FontDialog1: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure ADOTopicT_DATEGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure tvChange(Sender: TObject; Node: TTreeNode);
    procedure PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure ADOTopicT_SUBJECTGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure WebBrowser1BeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ADOTopicAfterScroll(DataSet: TDataSet);
    procedure ToolButton7Click(Sender: TObject);
    procedure ADOTopicT_AUTHORGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure WebBrowserDemoBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure WebBrowserDemoNewWindow2(Sender: TObject;
      var ppDisp: IDispatch; var Cancel: WordBool);
    procedure FormActivate(Sender: TObject);
    procedure WebBrowserDemoDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure ToolButton9Click(Sender: TObject);
    procedure ADOTopicAfterOpen(DataSet: TDataSet);
    procedure ToolButton11Click(Sender: TObject);
    procedure ToolButton13Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    oldDBGridProc:TWndMethod;
    procedure DBGirdProc(var Message: TMessage);
    procedure TopTree;
    procedure SubTree(pnd:TTreeNode;cat_id:string);
    procedure ShowTopic(topic_id:string);
    procedure CopyTable(tbname, keyname: string;sql:string='');
    function selectMDB(connect:TADOConnection;smdb:string=''):Boolean;
    function selectMDB2(connect:TADOConnection;smdb:string=''):Boolean;
    { Public declarations }
  end;

var
  fmMain: TfmMain;
  gb_Debug:Boolean;
  FirstTime:boolean=true;

function cvtDatestr(s:string):string;
implementation

uses util, GBBIG, Search,progress,registry,zlib,uwebSearch;
{$R *.dfm}

function TDBGrid.DoMouseWheel(Shift: TShiftState; WheelDelta: Integer;
MousePos: TPoint): Boolean;
begin
//if WheelDelta < 0 then
//datasource.DataSet.Next;
//if wheelDelta > 0 then
//DataSource.DataSet.Prior;
end;


procedure WriteRegistry(Dir,Name,Value:string);
var reg: Tregistry;
begin
   reg:=Tregistry.Create;
   reg.RootKey:=HKEY_LOCAL_MACHINE;
   reg.OpenKey('Software\'+Dir,true);
   reg.WriteString(Name,Value);
   reg.free;
end;
function ReadRegistry(DIR,Name:string):string;
var reg: Tregistry;
begin
   reg:=Tregistry.Create;
   reg.RootKey:=HKEY_LOCAL_MACHINE;
   reg.OpenKey('Software\'+Dir,true);
   result:=reg.ReadString(name);
   reg.free;
end;

function CompressFile(const SrcFile,DestFile:String):Boolean;
const Level: TCompressionLevel=clDefault;
var
  des:TMemoryStream;
  sou:TMemoryStream;
  cs: TCompressionStream;
  Count: Integer;
  ret:boolean;
begin
  ret:=false;
  des:=TMemoryStream.Create;
  sou:= TMemoryStream.Create;
  cs:=TCompressionStream.Create(level,des);
  try
    sou.LoadFromFile(SrcFile);
    Count:=sou.Size;
    sou.SaveToStream(cs);
    cs.Free;

    sou.Clear;
    sou.WriteBuffer(Count, SizeOf(Count));
    sou.CopyFrom(des,0);

    des.Clear;

    des.Seek(0,soFromBeginning);
    des.CopyFrom(sou,0);
    des.SaveToFile(DestFile);
    ret:=true;
  finally
    des.Free;
    sou.Free;
    result:=ret;
  end;
end;

function DeCompressFile(const SrcFile,DestFile:String):boolean;
var
  des:TFileStream;
  sou:TMemoryStream;
  decs: TDeCompressionStream;
  Buffer: PChar;
  Count: integer;
  ret:boolean;
begin
  Buffer:=nil;
  ret:=false;
  des:=TFileStream.Create(DestFile,fmCreate);
  sou:= TMemoryStream.Create;
  decs:=nil;
  try
    sou.LoadFromFile(SrcFile);
    sou.Seek(0,soFromBeginning);
    sou.ReadBuffer(count,sizeof(count));
    GetMem(Buffer, Count);
    decs:=TDeCompressionStream.Create(sou);
    decs.ReadBuffer(Buffer^, Count);
    Des.WriteBuffer(Buffer^, Count);
    Des.Position := 0;
    ret:=true;
  finally
    FreeMem(Buffer);
    decs.Free;
    des.Free;
    sou.Free;
    result:=ret;
  end;
end;

function GetAssociatedExecutable(FileExt: string; var FileDesc, MIMEType: string): string;
var
  Reg: TRegistry;
  FileType: string;
begin
  Result := '';

  if FileExt[1] <> '.' then FileExt := '.' + FileExt;

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKey_Classes_Root;
    if not Reg.OpenKey(FileExt, False) then Exit;

    FileType := Reg.ReadString('');
    MIMEType := Reg.ReadString('Content Type');
    Reg.CloseKey;

    if (FileType = '') or (not Reg.OpenKey(FileType, False)) then Exit;

    FileDesc := Reg.ReadString('');

    if not Reg.OpenKey('shell\open\command', False) then Exit;
    Result := Reg.ReadString('');
    Reg.CloseKey;
    if Pos(' ', Result) <> 0 then Result := Copy(Result, 1, Pos(' ', Result)-1);
    // truncate the '%1' from executable path, ex. 'c:\winword.exe %1' -> 'c:\winword.exe'
  finally
    Reg.Free;
  end;
end;

function SetAssociatedExecutable(FileExt, Filetype, FileDesc, MIMEType, ExecutablePath: string): Boolean;
// FileType, FileDesc and MIMEType is optional.
var
  Reg: TRegistry;
begin
  Result := False;

  if (FileExt = '') or (ExecutablePath = '') then Exit;

  if FileExt[1] <> '.' then FileExt := '.' + FileExt;
  // 'doc' -> '.doc'

  if FileType = '' then FileType := Copy(FileExt, 2, Length(FileExt) - 1) + 'file';
  // if not specify FileType, then assign FileType as FileExtenstion+'file'
  // ex. '.doc' -> 'docfile'

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKey_Classes_Root;
    if not Reg.OpenKey(FileExt, True) then Exit;

    Reg.WriteString('', FileType);
    if MIMEType <> '' then Reg.WriteString('Content Type', MIMEType);  // Write MIMEType
    Reg.CloseKey;


    if not Reg.OpenKey(FileType, True) then Exit;

    Reg.WriteString('', FileDesc);          // write File Description

//    if Pos('%1', ExecutablePath) = 0 then ExecutablePath := Trim(ExecutablePath) ;
    // append the executable path with ' %1', ex. 'c:\winword.exe' -> 'c:\winword.exe %1'

    if not Reg.OpenKey('shell\open\command', True) then Exit;
    Reg.WriteString('', ExecutablePath+' %1');     // write the executable path
    Reg.CloseKey;

    if not Reg.OpenKey(FileType+'\DefaultIcon', True) then Exit;
    Reg.WriteString('', ExecutablePath+',0');     // write the executable path
    Reg.CloseKey;

  finally
    Reg.Free;           // always free
  end;
end;


{ TfmMain }
function cvtDatestr(s:string):string;
begin
  Result:=copy(s,1,4)+'/'+copy(s,5,2)+'/'+copy(s,7,2)+' '+copy(s,9,2)+':'+
        copy(s,11,2)+':'+copy(s,13,2);
end;
function cvtDatestr2(s:string):string;
begin
  Result:=copy(s,1,4)+'/'+copy(s,5,2)+'/'+copy(s,7,2)+'<br>'+copy(s,9,2)+':'+
        copy(s,11,2)+':'+copy(s,13,2);
end;

procedure TfmMain.SubTree(pnd:TTreeNode;cat_id:string);
var qrysub:TADOQuery;
  nd:TTreenode;
begin
  qrysub:=ADOSQLCreate('select CAT_ID,CAT_NAME from FORUM_CATEGORY where CAT_PID='
                       +cat_id+' ORDER BY CAT_ORDER');
  try
    while not qrysub.Eof do begin
      nd:=tv.Items.AddChild(pnd,qrysub.FieldbyName('CAT_NAME').asstring);
      subTree(nd, qrysub.fieldbyname('CAT_ID').AsString);
      qrysub.Next;
    end;
    ADOSQLOpen(qrysub,'select FORUM_ID,F_SUBJECT from FORUM_FORUM '+
                      'where CAT_ID='+cat_id+' order by FORUM_ID');
    while not qrysub.Eof do begin
       tv.Items.AddChildobject(pnd,qrysub.FieldbyName('F_SUBJECT').asstring,
                        pointer(qrysub.FieldbyName('FORUM_ID').asinteger));
       qrysub.Next;
    end;
  finally
    qrysub.Free;
  end;
end;

procedure TfmMain.TopTree;
var qry:TADOQuery;
  rootnd,nd:TTreenode;
begin
  FormProgress.Show;
  tv.Items.Clear;
  rootnd:=tv.Items.AddChild(nil,'Delphi K.TOPQװ');
  qry:=ADOSQLCreate('select CAT_ID,CAT_NAME from FORUM_CATEGORY where CAT_PID=0'+
                    ' order by CAT_ORDER' );
  FormProgress.ProgressBar1.Max:=qry.RecordCount;
  FormProgress.ProgressBar1.Position:=0;
  try
    while not qry.Eof do begin
      nd:=tv.Items.AddChild(rootnd,qry.FieldbyName('CAT_NAME').asstring);
      subTree(nd, qry.fieldbyname('CAT_ID').AsString);
      qry.next;
      FormProgress.ProgressBar1.Position:=FormProgress.ProgressBar1.Position+1;
    end;
  finally
    qry.free;
  end;
  FormProgress.Close;
  tv.Items[0].Expanded:=true;
end;

procedure TfmMain.FormCreate(Sender: TObject);
var s:string;
begin
  SetAssociatedExecutable('.KTP','','K.Top Package','',application.exename);
  webbrowserDemo.Navigate('http://delphi.ktop.com.tw/ktoppack/demo.html');
  TabSheet1.TabVisible:=gb_Debug;
  TabSheet2.TabVisible:=gb_Debug;
  g_Connect:=ADOConnection1;
  webbrowser1.Navigate('about:blank');
  setmap;
  oldDBGridProc:=DBGrid1.WindowProc;
  DBGrid1.WindowProc:=DBGirdProc;
  caption:=caption+ver;
  s:=ReadRegistry('KTOP_Reader','DefaultFontSize');
  if s<>'' then font.size:=strtointdef(s,font.Size);
  s:=ReadRegistry('KTOP_Reader','DefaultFontName');
  if s<>'' then font.name:=s;

  s:=ReadRegistry('KTOP_Reader','WindowMax');
  if (s='Y') or (s='') then
  begin
    WindowState:=wsMaximized;
  end
  else
  begin
    WindowState:=wsNormal;
    s:=ReadRegistry('KTOP_Reader','WindowLeft');
    left:=strtointdef(s,left);
    s:=ReadRegistry('KTOP_Reader','WindowTop');
    top:=strtointdef(s,top);
    s:=ReadRegistry('KTOP_Reader','WindowWidth');
    Width:=strtointdef(s,Width);
    s:=ReadRegistry('KTOP_Reader','WindowHeight');
    Height:=strtointdef(s,Height);
  end;
  s:=ReadRegistry('KTOP_Reader','Panel3Height');
  if s<>'' then panel3.height:=strtointdef(s,panel3.height);
  s:=ReadRegistry('KTOP_Reader','Panel4Width');
  if s<>'' then panel4.Width:=strtointdef(s,panel4.Width);
end;

procedure TfmMain.ADOTopicT_DATEGetText(Sender: TField; var Text: String;
  DisplayText: Boolean);
begin
  Text:=copy(cvtDateStr(Sender.asstring),1,10);
end;

procedure TfmMain.ShowTopic(topic_id:string);
var v:Variant;
  HTMLDocument: IHTMLDocument2;
  ws:widestring;
begin
  ADOSqlOpen(Topic,'select FORUM_ID,TOPIC_ID,T_DATE,T_SUBJECT,T_CODESYSTEM,T_AUTHOR,'+
                'T_REPLIES,T_LAST_POST,T_GOOD,T_MESSAGE,M_NAME,T_FILENAME,T_FILESIZE '+
                ' from FORUM_TOPICS,FORUM_MEMBERS where TOPIC_ID='+topic_id+
                ' and FORUM_TOPICS.T_AUTHOR=FORUM_MEMBERS.MEMBER_ID');
  ADOSqlOpen(Reply,'select R_MESSAGE,M_NAME,R_DATE,R_CODESYSTEM '+
                   ' from FORUM_REPLY,FORUM_MEMBERS where TOPIC_ID='+topic_id+
                   ' and FORUM_REPLY.R_AUTHOR=FORUM_MEMBERS.MEMBER_ID ORDER BY R_DATE');
  if not Topic.IsEmpty then begin
    ws:=PageProducer1.Content;
    v := VarArrayCreate([0,0],varVariant);
    v[0] := ws;
    HTMLDocument := WebBrowser1.Document as IHTMLDocument2;
    HTMLDocument.write(pSafearray(TVarData(v).VArray));
    HTMLDocument.close;
  end;
end;

procedure TfmMain.tvChange(Sender: TObject; Node: TTreeNode);
var id:integer;
begin
  if node <> nil then begin
    id:=integer(node.Data);
    if id > 0 then begin
      ADOSqlOpen(adoTopic,'select * from FORUM_TOPICS'+
                ' where FORUM_ID='+inttostr(id)+' ORDER BY T_LAST_POST DESC');
    end;
  end;
end;

function ModifyMessageStr(ws:WideString;CodeSystem:integer=0):WideString;
var n1,n2,n3,i,n,len:integer;
  s:WideString;
begin
  s:=ws;
  if CodeSystem=1 then
    s:=gb2Big5(s);
//  s:=AnsiReplaceStr(Trim(s), '[url]','<a href="');
  while True do begin
    n1:=pos('[url=',s);
    if n1=0 then break;
    n2:=pos(']',copy(s,n1,length(s)));
    n3:=pos('[/url]',copy(s,n1,length(s)));
    n2:=n1+n2-1;
    n3:=n1+n3-1;
//    n3:=pos('[/url]',s);
    s:=copy(s,1,n1-1)+'<a href='+copy(s,n1+5,n2-n1-5)+'>'+
       copy(s,n2+1,n3-n2-1)+'</a>'+
       copy(s,n3+6,length(s));
  end;
  while True do begin
    n1:=pos('[url]',s);
    if n1=0 then break;
    n3:=pos('[/url]',copy(s,n1,length(s)));
    n3:=n1+n3-1;
//    n3:=pos('[/url]',s);
    s:=copy(s,1,n1-1)+'<a href='+copy(s,n1+5,n3-n1-5)+'>'+
       copy(s,n1+5,n3-n1-5)+'</a>'+
       copy(s,n3+6,length(s));
  end;

//  s:=AnsiReplaceStr(Trim(s), '[url]','<a href="');
//  s:=AnsiReplaceStr(Trim(s), '[/url]','">s</a>');
    {
  while True do begin
    n1:=pos('[url]',s);
    if n1=0 then break;
    n2:=pos(']',s);
    s[n2]:='>';
    n3:=pos('[/url]',s);
    s:=copy(s,1,n1-1)+'<a href='+copy(s,n1+5,n3-n1-5)+'</a>'+
       copy(s,n3+6,length(s)-n3-5);
  end;
  while True do begin
    n1:=pos('[url=',s);
    if n1=0 then break;
    n2:=pos(']',s);
    s[n2]:='>';
    n3:=pos('[/url]',s);
    s:=copy(s,1,n1-1)+'<a href='+copy(s,n1+5,n3-n1-5)+'</a>'+
       copy(s,n3+6,length(s)-n3-5);
  end;
  }
  n:=1;
  while True do begin
    len:=length(s);
    n1:=pos('http://',copy(s,n,len));
    if n1=0 then break;
    n1:=n+n1-1;
    n:=n1+10;
    if pos('href=',copy(s,n1-6,6))>0 then continue;
    if pos('src=',copy(s,n1-5,5))>0 then continue;
    n2:=n1+6;
    for i:=n1 to len  do
    begin
       if (s[i]<=' ') or (s[i]='<') or (s[i]='''') or (s[i]='"')or (s[i]='[')or (s[i]=',') or (i=len) then
       begin
          n2:=i-1;
          break;
       end;
    end;
    s:=copy(s,1,n1-1)+'<a href="'+copy(s,n1,n2-n1+1)+'">'+copy(s,n1,n2-n1+1)+'</a>'+copy(s,n2+1,len);
    n:=length(copy(s,1,n1-1)+'<a href="'+copy(s,n1,n2-n1+1)+'">'+copy(s,n1,n2-n1+1)+'</a>');
  end;
  n:=1;
  while True do begin
    len:=length(s);
    n1:=pos('<img src=icon_',copy(s,n,len));
    if n1=0 then break;
    n1:=n+n1-1;
    n:=n1+10;
    n2:=n1+6;
    for i:=n1+6 to len  do
    begin
       if (s[i]<=' ') then
       begin
          n2:=i-1;
          break;
       end;
    end;
    s:=copy(s,1,n1-1)+'<img src="http://delphi.ktop.com.tw/'+copy(s,n1+9,n2-n1+1-9)+'" '+copy(s,n2+1,len);
  end;
  s:=AnsiReplaceStr(Trim(s), #13#10,'<br>');
  Result:=s;
end;

procedure TfmMain.PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
var wss,ws:WideString;
begin
  if CompareText(TagString,'F_SUBJECT') = 0 then
    ReplaceText:=ADOGetValue('SELECT F_SUBJECT FROM FORUM_FORUM WHERE FORUM_ID='+Topic.fieldbyname('FORUM_ID').asString)
  else if CompareText(TagString,'T_SUBJECT') = 0 then
    ReplaceText:=Topic.fieldbyname('T_SUBJECT').asString
  else if CompareText(TagString,'T_AUTHOR') = 0 then
    ReplaceText:=Topic.fieldbyname('M_NAME').asstring
  else if CompareText(TagString,'T_REPLIES') = 0 then
    ReplaceText:=Topic.fieldbyname('T_REPLIES').asstring
  else if CompareText(TagString,'T_LAST_POST') = 0 then
    ReplaceText:=cvtDateStr(Topic.fieldbyname('T_LAST_POST').asstring)
  else if CompareText(TagString,'T_GOOD') = 0 then begin
    ReplaceText:='';
    if Topic.fieldbyname('T_GOOD').AsString='Y' then
      ReplaceText:='<font size=2 color=blue>峹</font>@';
    if trim(Topic.fieldbyname('T_FILENAME').AsString)<>'' then
    begin
      ReplaceText:=ReplaceText+'<a href=http://delphi.ktop.com.tw/link.asp?topic_id='+Topic.fieldbyname('TOPIC_ID').AsString+'><font size=2 color=blue>ɮפU('+Topic.fieldbyname('T_FILESIZE').AsString+' Bytes)</font></a>';
    end;
    if ReplaceText<>'' then ReplaceText:=ReplaceText+'<br>';
  end
  else if CompareText(TagString,'REPLY') = 0 then begin
    wss:=ModifyMessageStr(Topic.fieldbyname('T_MESSAGE').AsString,Topic.fieldbyname('T_CODESYSTEM').AsInteger);
    ws:='<tr>'+
        '<td bgcolor="whitesmoke" align=left valign=top><font face="Verdana, Arial, Helvetica" color="midnightblue" size="2"><b>'+Topic.fieldbyname('M_NAME').asstring+'</b><br>'
        +cvtDateStr2(Topic.fieldbyname('T_DATE').asstring)+'</font></td><td bgcolor="whitesmoke"  align=left  valign=top><font face="Verdana, Arial, Helvetica" color="midnightblue" size="2">'+wss+'</font></td></tr>';
if gb_debug then begin
  Memo1.Lines.Clear;
  Memo1.lines.Add(wss);
end;
    while not Reply.Eof do begin
      wss:=ModifyMessageStr(Reply.fields[0].asstring,Reply.fieldbyname('R_CODESYSTEM').AsInteger);
      ws:=ws+'<tr><td bgcolor="whitesmoke" align=left  valign=top><font face="Verdana, Arial, Helvetica" color="midnightblue" size="2"><b>'+Reply.FieldByName('M_NAME').asstring+'</b><br>'
            +cvtDateStr2(Reply.FieldByName('R_DATE').asstring)+'</font></td><td bgcolor="whitesmoke"  align=left valign=top><font face="Verdana, Arial, Helvetica" color="midnightblue" size="2">'+wss+'</td>';
if gb_debug then begin
  memo1.Lines.add('*****'+Reply.fields[1].asstring+'*****');
  memo1.Lines.add(Reply.fields[0].asstring);
end;
        Reply.Next;
    end;
    ReplaceText:=ws;
  end;
end;

procedure TfmMain.ADOTopicT_SUBJECTGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if Sender.DataSet.fieldbyname('T_CODESYSTEM').AsInteger=1 then
    Text:=gb2big5(Sender.asstring)
  else
    Text:=Sender.asstring;
end;

procedure TfmMain.WebBrowser1BeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var topicid:String;
  n:integer;
begin
  topicid:=URL;
  n:=pos('TOPIC.ASP?TOPIC_ID=',AnsiUpperCase(topicid));
  if n > 0 then begin
    Cancel:=True;
    topicid:=AnsiUpperCase(topicid);
    fetch(topicid,'TOPIC_ID=',True);
    showtopic(topicid);
  end;
end;

procedure TfmMain.CopyTable(tbname,keyname:string;sql:string='');
var qrysrc:TADOQuery;
  qryDst:TADOCommand;
  fields,swhere,fldname,ss,strInsert:string;
  i:integer;
  d1:TDateTime;
begin
//d1:=now;
  if sql='' then sql:='select * from '+tbname;
  qrysrc:=ADOSQLCreate(sql,ADOConnection2);
  try
    if not qrysrc.isEMpty then begin
      for i:=0 to qrysrc.FieldCount-1 do
        fields:=fields+','+qrysrc.Fields[i].FieldName;
      delete(fields,1,1);

      strInsert:='insert into '+tbname+' ('+fields+') values(:'+
                 AnsiReplaceStr(fields,',',',:')+')';
      qryDst:=TADOCommand.Create(self);
      qryDst.Connection:=AdoConnection1;
      qrydst.CommandText:=strInsert;
      qryDst.Prepared:=True;
      try
        while not qrysrc.Eof do begin
          ss:=keyname;swhere:='';
          repeat
            fldname:=GetToken(';',ss);
            swhere:=swhere+' and '+fldname+'='+varstr(qrysrc[fldname]);
          until Trim(ss)='';
          delete(swhere,1, 4);

//          if ADOGetValue('select count(*) from '+tbname+' where '+swhere)=0 then
          ADOSQLExec('DELETE FROM '+tbname+' where '+swhere,AdoConnection1);
          begin
            for i:=0 to qrysrc.FieldCount-1 do
              qryDst.Parameters[i].Value:=qrysrc.fields[i].Value;
            qrydst.Execute;
          end;
          qrysrc.next;
        end;
      finally
        qrydst.free;
      end;
    end;
  finally
    qrysrc.free;
  end;
//showmessage(Inttostr(Trunc((now-d1)*3600*24)));
end;

procedure TfmMain.ToolButton1Click(Sender: TObject);
begin
  OpenDialog1.title:='פJɥR].KTP/.MDB';
  if SelectMDB2(AdoConnection2) then begin
    if pos('.ktp',AdoConnection2.ConnectionString)>0 then
    begin
     if DeCompressFile(AdoConnection2.ConnectionString,stringreplace(AdoConnection2.ConnectionString,'.ktp','.mdb',[])) then
     begin
       AdoConnection2.ConnectionString:=stringreplace(AdoConnection2.ConnectionString,'.ktp','.mdb',[]);
     end
     else exit;
    end;
    AdoConnection2.Open;
    StatusBar1.SimpleText:='פJ|...';
    application.ProcessMessages;
    CopyTable('FORUM_MEMBERS','MEMBER_ID');

    StatusBar1.SimpleText:='פJؿ...';
    application.ProcessMessages;
    CopyTable('FORUM_CATEGORY','CAT_ID');

    StatusBar1.SimpleText:='פJQװϸ...';
    application.ProcessMessages;
    CopyTable('FORUM_FORUM','FORUM_ID');

    StatusBar1.SimpleText:='פJDD峹...';
    application.ProcessMessages;
    CopyTable('FORUM_TOPICS','TOPIC_ID');

//    CopyTable('FORUM_TOPICS','TOPIC_ID','select * from FORUM_TOPICS where T_DATE>'+Quotedstr('200212'));
    StatusBar1.SimpleText:='פJ^Ф峹...';
    application.ProcessMessages;
    CopyTable('FORUM_REPLY','TOPIC_ID;REPLY_ID');

    StatusBar1.SimpleText:='ؾ𪬹...';
    application.ProcessMessages;
    TopTree;
    StatusBar1.SimpleText:='';
    ShowMessage('ɥR]פJ\!');
  end;

end;

function TfmMain.selectMDB(connect:TADOConnection;smdb:string=''):Boolean;
var l:TStringlist;
  dbname:string;
begin
  Result:=False;
  if smdb='' then begin
    OpenDialog1.Filter := 'Access File|*.mdb';
    if OpenDialog1.Execute then
      smdb:=OpenDialog1.filename;
  end;
  if smdb <> '' then begin
//    l:=TStringlist.create;
   // l:=StrTOList(connect.ConnectionString,';',False);
    connect.Close;
//    l.values['Data Source']:=smdb;
//    connect.ConnectionString:=ListTOStr(l);
    connect.ConnectionString:=smdb;
    connect.Open;
//    l.Free;
  Result:=True;
  end;
end;
function TfmMain.selectMDB2(connect:TADOConnection;smdb:string=''):Boolean;
var l:TStringlist;
  dbname:string;
begin
  Result:=False;
  if smdb='' then begin
    OpenDialog1.Filter := 'KTop Package File(*.KTP)|*.ktp|Access File(*.MDB)|*.mdb';
    if OpenDialog1.Execute then
      smdb:=OpenDialog1.filename;
  end;
  if smdb <> '' then begin
//    l:=TStringlist.create;
   // l:=StrTOList(connect.ConnectionString,';',False);
    connect.Close;
//    l.values['Data Source']:=smdb;
//    connect.ConnectionString:=ListTOStr(l);
    connect.ConnectionString:=smdb;
//    connect.Open;
//    l.Free;
  Result:=True;
  end;
end;

procedure TfmMain.ToolButton2Click(Sender: TObject);//connect database
begin
  OpenDialog1.title:='ܸƮwӷMDB';
  if selectMDB(AdoConnection1) then
    TopTree;
end;

procedure TfmMain.ToolButton3Click(Sender: TObject);
var i:integer;
  found:Boolean;
begin
  found:=False;
  for i:=0 to Screen.FormCount - 1 do
    if Screen.Forms[i] is TfmSearch then begin
      if Screen.Forms[i].WIndowState = wsMinimized then
        Screen.Forms[i].WindowState := wsNormal
      else
        Screen.Forms[i].BringToFront;
      found:=True;
      break;
    end;
  if not found then
    with TfmSearch.Create(self) do
      showmodal;
end;

procedure TfmMain.FormShow(Sender: TObject);
begin
  if selectMDB(ADOConnection1,AddSlash(ExtractFilePath(application.ExeName))+'ktop.mdb') then
    TopTree;
end;

procedure TfmMain.ADOTopicAfterScroll(DataSet: TDataSet);
begin
  showtopic(adoTopic.fieldbyname('TOPIC_ID').asstring);
end;

procedure TfmMain.DBGirdProc(var Message: TMessage);
//begin
//  if (Message.Msg=WM_LBUTTONDOWN) or (Message.Msg=WM_VSCROLL) then
//    Windows.SetFocus(DBGrid1.Handle);
//  oldDBGridProc(Message);
//end;
var wheelDelta:smallint;
begin
if (Message.Msg=WM_MOUSEWHEEL) then begin
if not AdoTopic.IsEmpty then begin
wheelDelta := HIWORD(message.WParam);
// Label1.caption:=inttostr(wheeldelta);
if WheelDelta < 0 then
AdoTopic.Next;
if wheelDelta > 0 then
AdoTopic.Prior;
end;
end
else begin
if (Message.Msg=WM_LBUTTONDOWN) or (Message.Msg=WM_VSCROLL) then
Windows.SetFocus(DBGrid1.Handle);
oldDBGridProc(Message);
end;
end;




procedure TfmMain.ToolButton7Click(Sender: TObject);
begin
  webbrowser1.Navigate('http://delphi.ktop.com.tw/ktoppack/index.html');
end;

procedure TfmMain.ADOTopicT_AUTHORGetText(Sender: TField; var Text: String;
  DisplayText: Boolean);
begin
  if trim(sender.AsSTring)='' then
  text:=''
  else
  text:=ADOGetValue('SELECT M_NAME FROM FORUM_MEMBERS WHERE MEMBER_ID='+sender.AsSTring);
end;

procedure TfmMain.WebBrowserDemoBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var s:string;
begin
  s:=url;
//  showmessage(s);
  if pos('demo.html',s)=0 then
  if pos('demo2.html',s)=0 then
  begin
    ShellExecute(application.handle,pchar('OPEN'),pchar(s),nil,nil,0);
    Cancel:=true;
  end;
end;

procedure TfmMain.WebBrowserDemoNewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
begin
  cancel:=true;
  ppDisp:=nil;
end;

procedure TfmMain.FormActivate(Sender: TObject);
begin
  if firsttime then
  if paramcount>0 then
  begin
     firsttime:=false;
     if DeCompressFile(paramstr(1),AddSlash(ExtractFilePath(application.ExeName))+'temp.mdb') then
     begin
      OpenDialog1.title:='פJɥR]MDB';
      AdoConnection2.ConnectionString:=AddSlash(ExtractFilePath(application.ExeName))+'temp.mdb';

        StatusBar1.SimpleText:='פJ|...';
        application.ProcessMessages;
        CopyTable('FORUM_MEMBERS','MEMBER_ID');

        StatusBar1.SimpleText:='פJؿ...';
        application.ProcessMessages;
        CopyTable('FORUM_CATEGORY','CAT_ID');

        StatusBar1.SimpleText:='פJQװϸ...';
        application.ProcessMessages;
        CopyTable('FORUM_FORUM','FORUM_ID');

        StatusBar1.SimpleText:='פJDD峹...';
        application.ProcessMessages;
        CopyTable('FORUM_TOPICS','TOPIC_ID');

//////    CopyTable('FORUM_TOPICS','TOPIC_ID','select * from FORUM_TOPICS where T_DATE>'+Quotedstr('200212'));
        StatusBar1.SimpleText:='פJ^Ф峹...';
        application.ProcessMessages;
        CopyTable('FORUM_REPLY','TOPIC_ID;REPLY_ID');

        StatusBar1.SimpleText:='ؾ𪬹...';
        application.ProcessMessages;
        TopTree;
        StatusBar1.SimpleText:='';
        ShowMessage('ɥR]פJ\!');
     end;
  end;

end;

procedure TfmMain.WebBrowserDemoDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var s,s1,s2:string;
begin
  if pos('demo.html',url)>0 then
  begin
   s:=(webbrowserDemo.Document as IHtmlDocument2).Body.outerHTML;
   fetch(s,'NewVer=',True);
   s:=trim(copy(s,1,pos('>',s)-1));
//   GetToken('>',s);
   if s<>'' then
   begin
      if s>ver then
      begin
        ToolButton7Click(sender);
        showMessage('wgsVer'+s+'{AЧs!')
      end;
   end;
  end;
end;

procedure TfmMain.ToolButton9Click(Sender: TObject);
begin
//
   AdoTopic.Close;
   AdoTopic.sql.Clear;
   AdoTopic.sql.add('SELECT * FROM FORUM_TOPICS WHERE T_SUBJECT LIKE ''%'+editsearch.text+'%'' OR T_MESSAGE LIKE ''%'+editsearch.text+'%''');
   AdoTopic.sql.add('or TOPIC_ID IN (SELECT TOPIC_ID FROM FORUM_REPLY WHERE R_MESSAGE LIKE ''%'+editsearch.text+'%'')');
   AdoTopic.open;
   if AdoTopic.eof then ShowMessage('dL');

end;

procedure TfmMain.ADOTopicAfterOpen(DataSet: TDataSet);
begin
//   StatusBar1.SimpleText:='`:'+inttostr(adoTopic.recordcount);
end;

procedure TfmMain.ToolButton11Click(Sender: TObject);
begin
   WebSearch;
end;

procedure TfmMain.ToolButton13Click(Sender: TObject);
begin
  fontdialog1.font:=font;
  if fontdialog1.Execute then
  begin
     font.Size:=fontdialog1.font.size;
     font.name:=fontdialog1.font.name;
     WriteRegistry('KTOP_Reader','DefaultFontSize',inttostr(fontdialog1.font.size));
     WriteRegistry('KTOP_Reader','DefaultFontName',fontdialog1.font.Name);
  end;
end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    if WindowState=wsMaximized then
    WriteRegistry('KTOP_Reader','WindowMax','Y')
    else
    WriteRegistry('KTOP_Reader','WindowMax','N');

    WriteRegistry('KTOP_Reader','WindowLeft',inttostr(left));
    WriteRegistry('KTOP_Reader','WindowTop',inttostr(Top));
    WriteRegistry('KTOP_Reader','WindowWidth',inttostr(width));
    WriteRegistry('KTOP_Reader','WindowHeight',inttostr(height));

    WriteRegistry('KTOP_Reader','Panel3Height',inttostr(Panel3.Height));
    WriteRegistry('KTOP_Reader','Panel4Width',inttostr(Panel4.Width));

end;

initialization
  OleInitialize(nil);

finalization
  OleUninitialize;

end.


