unit Search;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, DBGrids, DB, ADODB,strutils, ComCtrls,
  Buttons;

type
  TfmSearch = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    Label2: TLabel;
    cbDate: TComboBox;
    Label3: TLabel;
    edMember: TEdit;
    Label4: TLabel;
    cbField: TComboBox;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    cbForum: TComboBox;
    Panel3: TPanel;
    Panel4: TPanel;
    ScrollBox1: TScrollBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure DBGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure AddDisGroup;
    { Public declarations }
  end;

var
  fmSearch: TfmSearch;

implementation

uses util, main, GBBIG;

{$R *.dfm}

procedure TfmSearch.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TfmSearch.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfmSearch.FormCreate(Sender: TObject);
var qry:TADoQuery;
  i,y:integer;
  chk:TCheckBox;
begin
  height:=250;
{
// CREATE CHECK BOX
  qry:=ADOSQLCreate('select CAT_ID,CAT_NAME from FORUM_CATEGORY where CAT_PID=0'+
                    ' order by CAT_ORDER' );
  y:=10;
  try
    while not qry.eof do begin
      with TCheckbox.create(self) do begin
        parent:=ScrollBox1;
        left:=12;
        top:=y;
        y:=y+18;
        Caption:=qry.fields[1].asstring;
        tag:=qry.fields[0].asinteger;
      end;
      qry.next;
    end;
  finally
    qry.free;
  end;
}
  AddDisGroup;
  cbForum.ItemIndex:=0;
end;

procedure TfmSearch.AddDisGroup;
  procedure AddItem(sCaption:string; id:integer);
  begin
    cbForum.Items.AddObject(sCaption,TObject(id));
  end;
var qry:TADOQuery;
begin
  Additem('Qװ',0);
  qry:=ADOSQLCreate('SELECT * FROM FORUM_FORUM,FORUM_CATEGORY WHERE FORUM_FORUM.CAT_ID=FORUM_CATEGORY.CAT_ID AND CAT_PID=0 ORDER BY CAT_ORDER,CAT_NAME,F_SUBJECT ' );
  try
    while not qry.Eof do begin
      Additem(qry.FieldbyName('F_SUBJECT').asstring,qry.FieldbyName('FORUM_ID').asInteger);
      qry.next;
    end;
  finally
    qry.free;
  end;
(*
  AddItem('hh[cε{}oQװ',        68);
  AddItem('JkPr{]pQװ',        76);
  AddItem('C{]pQװ',                75);
  AddItem('vhC{]pQװ',          74);
  AddItem('g]Ƶ{]pQװ',            73);
  AddItem('Win32 API ϥΰQװ',              72);
  AddItem('VCL ϥΩγ]pQװ',          71);
  AddItem('Ʈw{]pQװ',              66);
  AddItem('HkDDQװ',              69);
  AddItem('ں{]pQװ',            67);
  AddItem(']p}oQװ',                100);
  AddItem('Object PascalɦVQװ',       70);
  AddItem('Pŷ|Ѽֳ',                    925);
  AddItem('|Delphi/BCBnnѱM',    81);
  AddItem('|^mɮפWǱM',          77);
  AddItem('|DU{ɮפWǰ',            97);
  AddItem('o峹ɦs',            130);
  AddItem('|@~o',                    79);
  AddItem('oհ',                        911);
  AddItem('䥦{yQװ',                999);
  AddItem('ͤʳsa',              107);
  AddItem('²P̷s',                88);
  AddItem('@ϵsMQװ',              898);
  AddItem('LINUXDQװ',               900);
  AddItem('KYLIXQװ',                       901);
  AddItem('e-Bookql`',                  902);
  AddItem('e-BookqlѨϥΰQװ',            904);
  AddItem('C{]pQװ(BCB)',           919);
  AddItem('HkDDQװ(BCB)',         923);
  AddItem('ں{]pQװ(BCB)',       920);
  AddItem('Ʈw{]pQװ(BCB)',         918);
  AddItem('g]Ƶ{]pQװ(BCB)',       917);
  AddItem(']p}oQװ(BCB)',           916);
  AddItem('Win32 API ϥΰQװ(BCB)',         914);
  AddItem('VCL ϥΩγ]pQװ(BCB)',     913);
  AddItem('C++{yQװ(BCB)',            912);
  AddItem('vhC{]pQװ(BCB)',     921);
  AddItem('bruce0211---BCBM',               936);
  AddItem('ƵcPtkQװ',          963);
  AddItem('JAVA{]pQװ',            981);
  AddItem('Borland TaiwanM',                973);
  AddItem('uVCL How To - ioϡv',       957);
  AddItem('DelphiWWW---qlM',            943);
  AddItem('e-Book 2.0 oζM',           928);
  AddItem('M---DelphiQװ',           949);
*)
end;
procedure TfmSearch.DBGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var c:TGridCoord;
begin
end;

procedure TfmSearch.BitBtn1Click(Sender: TObject);
var ssql,swhere,s,ss,smatch,subwhere,sop:string;
  catlist:string;
  forumid,i,id:integer;
  today:TDateTime;
  qry:TADOQuery;
begin
  ss:=Trim(Edit1.text);
  ssql:='select distinct FORUM_TOPICS.TOPIC_ID,FORUM_TOPICS.FORUM_ID,T_DATE,T_SUBJECT,T_CODESYSTEM,T_AUTHOR,T_REPLIES,'+
        'T_LAST_POST,T_GOOD from FORUM_TOPICS';
  if ss <> '' then begin
    if RadioGroup1.ItemIndex=0 then
      smatch:='(T_SUBJECT='+QuotedStr(ss)+')'
    else begin
     if RadioGroup1.ItemIndex=1 then sop:=' and '
                                else sop:=' or  ';
      repeat
        s:=gettoken(' ',ss);
        smatch := smatch+sop+'T_SUBJECT like ''%'+s+'%''';
      until Trim(ss)='';
      delete(smatch,1,4);
      smatch:='('+smatch+')';
    end;

    if cbField.ItemIndex =0 then begin //search all field, need FORUM_REPLY
      subwhere:=AnsiReplaceStr(smatch, 'T_SUBJECT','R_MESSAGE');
      smatch:=' ('+smatch+' or '+AnsiReplaceStr(smatch, 'T_SUBJECT','T_MESSAGE')+')';
      if Trim(EdMember.text)='' then
        swhere:= 'and ('+smatch+' or '+subwhere+')';
    end
    else begin
      if Trim(EdMember.text)='' then
        swhere:= 'and '+smatch;
    end;
  end;
  if Trim(EdMember.text)<>'' then begin  //need search member
    if smatch <> '' then smatch:=' and '+smatch;
    if subwhere <> '' then subwhere:=' and '+subwhere;
    s:=ADOGetValue('select MEMBER_ID from FORUM_MEMBERS where M_NAME='+QuotedStr(Edmember.text));
    if s <> '' then begin
      smatch:='T_AUTHOR='+ s + smatch;
      if cbField.ItemIndex <> 0 then
        swhere:= ' and ('+smatch+')'
      else begin    //search all field, need FORUM_REPLY
        subwhere:=' R_AUTHOR='+s+subwhere;
        swhere:=' and (('+smatch+') or ('+subwhere+'))';
      end;
    end
    else
      Raise Exception.create('䤣|'+EDMember.text);
  end;

  toDay:=Date;
  case cbDate.ItemIndex of
    0:;
    1: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',toDay-1));
    2: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',toDay-3));
    3: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',toDay-7));
    4: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',toDay-14));
    5: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',incmonth(Date,-1)));
    6: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',incmonth(Date,-2)));
    7: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',incmonth(Date,-3)));
    8: swhere:=swhere+' and T_DATE >='+QuotedStr(FormatDateTime('yyyymmdd',incmonth(Date,-12)));
  end;

  if cbForum.ItemIndex > 0 then begin  //Qװ
    forumid:=integer(cbForum.Items.Objects[cbForum.ItemIndex]);
    swhere := swhere+' and FORUM_TOPICS.FORUM_ID='+inttostr(forumid);
  end
  else begin //Qװ, ݤ
    catlist:=',';
    qry:=TADOQuery.create(self);
    try
      for i:=0 to Scrollbox1.ControlCount - 1 do begin//for each check box
        if TCheckBox(Scrollbox1.Controls[i]).Checked then begin
          ADOSQLOpen(qry,'select CAT_ID from FORUM_CATEGORY where CAT_KIND='+
                         inttostr(TCheckBox(Scrollbox1.Controls[i]).tag));
          while not qry.eof do begin
            if pos(','+qry.fields[0].AsString+',', catlist)=0 then
              catlist:=catlist+qry.fields[0].AsString+',';
            qry.next;
          end;
        end;
      end;
    finally
      qry.free;
    end;
    if length(catlist)>2 then
      catlist:=copy(catlist,2,length(catlist)-2);
    swhere := swhere + ' and FORUM_TOPICS.CAT_ID in ('+catlist+')';
  end;

  delete(swhere,1,4);
  if subwhere <> '' then
    ssql:=ssql+',FORUM_REPLY,FORUM_TOPICS left join FORUM_REPLY on FORUM_TOPICS.TOPIC_ID = FORUM_REPLY.TOPIC_ID';

  if checkbox6.Checked then swhere:=swhere+' AND T_GOOD=''Y''';
  if checkbox7.Checked then swhere:=swhere+' AND T_FIELNAME=''Y''';

  ssql:=ssql+' where '+swhere+'  ORDER BY T_LAST_POST DESC ';
//  showmessage(ssql);
  ADOSqlOpen(FmMain.adoTopic, ssql);
  if FmMain.adoTopic.IsEmpty then begin
//    height:=250;
//    StatusBar1.SimpleText:='䤣';
      FmMain.StatusBar1.SimpleText:='䤣';
      FmMain.adoTopic.close;
      ShowMessage('䤣');
      ModalResult:=mrNone;
  end
  else begin
//    if height < 260 then
//      height:=400;
//    StatusBar1.SimpleText:='`:'+inttostr(adoquery1.recordcount);
//      FmMain.StatusBar1.SimpleText:='`:'+inttostr(FmMain.adoTopic.recordcount);
      close;
  end;
end;

end.


