unit UWebBrowser;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw,comctrls;

type
  TFormWebBrowser = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
  private
    Firsttime:boolean;
    FormNo:integer;
    SearchItemName:string;
    SearchKey:string;
    { Private declarations }
  public
    { Public declarations }
  end;

function CreateWebBrowser(sender:tobject;url:string;FNo:integer;SName,Skey:string):IDispatch;

implementation

{$R *.dfm}
Procedure PostKeyEx32( key: Word; Const shift: TShiftState;
                     specialkey: Boolean );
  Type
    TShiftKeyInfo = Record
                      shift: Byte;
                      vkey : Byte;
                    End;
    byteset = Set of 0..7;
  Const
    shiftkeys: Array [1..3] of TShiftKeyInfo =
      ((shift: Ord(ssCtrl); vkey: VK_CONTROL ),
       (shift: Ord(ssShift); vkey: VK_SHIFT ),
       (shift: Ord(ssAlt); vkey: VK_MENU ));
  Var
    flag: DWORD;
    bShift: ByteSet absolute shift;
    i: Integer;
  Begin
    For i := 1 To 3 Do Begin
      If shiftkeys[i].shift In bShift Then
        keybd_event( shiftkeys[i].vkey,
                     MapVirtualKey(shiftkeys[i].vkey, 0),
                     0, 0);
    End; { For }
    If specialkey Then
      flag := KEYEVENTF_EXTENDEDKEY
    Else
      flag := 0;

    keybd_event( key, MapvirtualKey( key, 0 ), flag, 0 );
    flag := flag or KEYEVENTF_KEYUP;
    keybd_event( key, MapvirtualKey( key, 0 ), flag, 0 );

    For i := 3 DownTo 1 Do Begin
      If shiftkeys[i].shift In bShift Then
        keybd_event( shiftkeys[i].vkey,
                     MapVirtualKey(shiftkeys[i].vkey, 0),
                     KEYEVENTF_KEYUP, 0);
    End; { For }
  End; { PostKeyEx32 }


function CreateWebBrowser(sender:tobject;url:string;FNo:integer;SName,Skey:string):IDispatch;
begin
   with TFormWebBrowser.Create(Tcomponent(sender)) do
   begin
      FormNo:=FNo;
      SearchItemName:=SName;
      SearchKey:=SKey;
      Firsttime:=true;
      parent:=twincontrol(sender);
      Borderstyle:=bsnone;
      align:=alclient;
      WebBrowser1.Navigate(url);
      show;
      result:=WebBrowser1.DefaultDispatch;
   end;
end;

procedure TFormWebBrowser.WebBrowser1DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var Docs, Edits : OleVariant;
p:array[0..255] of pchar;
s:string;
begin
  if Firsttime then
  begin
    Firsttime:=false;
    if FormNo>=0 then
    begin
    try
//  Edits :=WebBrowser1.OleObject.Document.Forms.item(1).all.Item('Search', 0);
//  Edits.Value :='rs232s';
//    WebBrowser1.oleobject.document.Forms.Item(1,0).submit;
//      Edits :=WebBrowser1.OleObject.Document.Forms.item(FormNo).all.Item(SearchItemName, 0);
       s:=SearchItemName;
       if (s<>'') and (SearchKey<>'') then
       try
       if s='Search' then
        Edits :=WebBrowser1.OleObject.Document.Forms.item(FormNo).all.Item('Search', 0)
       else
       if s='String' then
        Edits :=WebBrowser1.OleObject.Document.Forms.item(FormNo).all.Item('String', 0)
       else
       if s='SearchStr' then
        Edits :=WebBrowser1.OleObject.Document.Forms.item(FormNo).all.Item('SearchStr', 0)
       else
       if s='KeyWord' then
        Edits :=WebBrowser1.OleObject.Document.Forms.item(FormNo).all.Item('KeyWord', 0)
       else
        Edits :=WebBrowser1.OleObject.Document.Forms.item(FormNo).all.Item(s, 0);
//      p:=pchar(SearchKey);
        Edits.Value :=SearchKey;
       except
       end;
       WebBrowser1.oleobject.document.Forms.Item(FormNo,0).submit;
    except
    end;
    end;
  end
  else
  begin
//    TTabsheet(WEbBrowser1.Parent).caption:=TTabsheet(WEbBrowser1.Parent).caption+'ok';
  end;
end;

end.
